package POE::Component::XOSD;

use POE qw( Session Wheel::Run );

sub new {
  my $proto = shift;
  my $class = ref( $proto ) || $proto;
  my $self = bless {}, $class;

  $self->{session} = POE::Session->new(
     _start => sub {
		 $self->{queue} = qw[ cat dog mouse ];
		 $self->{bin} = '/usr/X11R6/bin/osd_cat';
		 $_[KERNEL]->yield( 'moveQueue' );
               },
     moveQueue => sub {
		    my $text = shift @{ $self->{queue} };
		    if ( defined $text ) {
		      $_[KERNEL]->{xosd} = POE::Wheel::Run->new(
		        Program => "echo '$text' | $self->{bin}",
		        StdError => sub { print "An error occurred.\n"; }
		      );
		    }
		    $_[KERNEL]->yield( 'moveQueue' );
		  }
  );

  return $self;
}

sub print {
  my ( $self, $text ) = @_;
  push( @{ $self->{queue} }, $text );
}
1;
